# Võluruudu kontroll

# Sisendfailis on 3, 4 või 5 rida
# kontrollib, kas on ridu sama palju kui veerge ja ridu/veerge < 6
# a) kontrollib, kas ridade/veergude summad on võrdsed
# b) kontrollib, kas ka diagonaalide summad on ridade/veergudega võrdsed
#------------------------------------------------------------------------
# Muutujad:
# ruut - nimekirja tüüpi muutuja sisseloetud andmetega 
# on_ruut - tõeväärtus, kas on üldse tegemist ruuduga
# kokku_ruut - hulga tüüpi muutuja, milles hoitakse ridade, veergude ja diagonaalide summasid.
# Hulka peab jääma vaid üks liige, sest võrdseid summasid ei lisata. Vastupidisel juhul
# annab teate mittesobimisest.
# summa, summa1 ja summa2 - ridade, veergude, diagonaalide summad

import sys
fail = open("Sisend_III_5.txt","r")
# loeb sisse sisendfailist andmerea ilma reavahetuse märgendita
ruut = fail.read().splitlines()
print("Failis on ", len(ruut), "rida")
for i in range(len(ruut)):
    print(ruut[i])

for i in range(len(ruut)):
    ruut[i] = ruut[i].strip(" ") # lõikab ära kõik rea lõppu 
    # jäänud tühikud, mis on andmeid sisestades kogemata tekkinud
    ruut[i] = ruut[i].split(" ")  # jagab read ruudu elementideks

fail.close()

# kontrollib, kas on üldse ruut ja read-veerud täidavad 
# sisendi tingimusi
# on_ruut = True
if (len(ruut) <3) or (len(ruut) >5):
    print("Ridade arv peaks olema 3, 4 või 5")
    sys.exit()
for i in range(len(ruut)):
    if not (len(ruut[i]) == len(ruut)) :
        on_ruut = False
        print("Reas", i, "ebasobiv arv liikmeid")
        sys.exit() # ülesande tingimus pole täidetud, jätab kontrollimise katki

# Tekitame ruudu elementidest arvude massiivi
elemendid=[]
for i in range(len(ruut)):
    elemendid.append([])
    for j in range(len(ruut)):
        elemendid[i].append(int(ruut[i][j]))
        
# ------- a) kas ridade ja veergude summad on võrdsed
summade_hulk = set()
kontroll = True
for i in range(len(ruut)):
    summa = 0
    for j in range(len(ruut)):
        summa += elemendid[i][j]
    summade_hulk.add(summa)
    if len(summade_hulk) > 1:
        kontroll = False
        print("Real ", i, "on eelmistest erinev summa")
        sys.exit() # tingimus pole täidetud, jätab kontrollimise katki
    
#    summade_hulk = set()
for j in range(len(ruut)):
    summa = 0
    for i in range(len(ruut)):
        summa += elemendid[i][j]
    summade_hulk.add(summa)
    if len(summade_hulk) > 1:
        kontroll = False
        print("Veerul ", j, "on ridadest ja eelnevatest veergudest erinev summa")
        sys.exit() # tingimus pole täidetud, jätab kontrollimise katki

# ------- b) vaatame diagonaalide summasid
summa1, summa2 = 0,0
for i in range(len(ruut)):
    summa1 += elemendid[i][i]             #diagonaal ülevalt vasakult
    summa2 += elemendid[i][len(ruut)-i-1] #diagonaal ülevalt paremalt
summade_hulk.add(summa1)
summade_hulk.add(summa2)
if len(summade_hulk) > 1:
    kontroll = False
    print("diagonaalid ei ole ridade ja veergudega võrdse summaga")
    sys.exit()
if kontroll:
    print("Tegemist on võluruuduga")
    
   
