# Ülesanne V-3-1. Lõigu joonestamine otspunktide järgi
#================== Programm =============================
from tkinter import *
#----------------------------------------------------------------------------------
# Punkt koordinaatidega on kirjeldatud programmis (V-G) Punkt koordinaatidega.py

def punkt(koordinaadid,**kwargs):
    x = round(koordinaadid[0],2)
    y = round(koordinaadid[1],2)
    nimi = kwargs.get('nimi',None)
    #kas koordinaadid joonisele kirjutada (Y/N)?
    koord = kwargs.get('koord',None)
    tahvel.create_oval(x-1,y-1,x+2,y+2,fill='black')
    if nimi != None:
        silt=nimi
        if koord=='Y':
            silt=silt+'('+str(x)+','+str(y)+')'
        kesk = int(len(silt)/2)    #teksti keskkoht
        fondikorgus = 8
        tahvel.create_text(x-kesk,y+fondikorgus,font='Times '+str(fondikorgus), \
                           text=silt,fill='red')
    return
#----------------------------------------------------------
def lqik(A,B,Animi,Bnimi,**kwargs):  #Lõigu joonestamine punktide järgi
    # A ja B on lõigu otspunktide koordinaadid.
    # soovi korral võib lõigule ette anda lõigu värvi:
    vxrv = kwargs.get('vxrv', None)
    # Lõigu otspunktide märkimiseks kasutame funktsiooni punkt(koordinaadid,nimi)
    punkt(A, nimi = Animi)
    punkt(B, nimi = Bnimi)
    tahvel.create_line(A,B,fill=vxrv)
    return
#--------------------------------------------------------------------------------------
raam = Tk()
raam.title("Tahvel")
tahvel = Canvas(raam, width=800, height=600, background="white")
#Algandmete lugemine
fail = open("Sisend_V-G-1.txt","r")

Animi = fail.readline()[0]
avaldis = fail.readline()
A = avaldis.split(',')
A[0] = int(A[0])
A[1] = int(A[1])

Bnimi = fail.readline()[0]
avaldis = fail.readline()
B = avaldis.split(',')
B[0] = int(B[0])
B[1] = int(B[1])
fail.close()

lqik(A,B,Animi,Bnimi)

tahvel.pack()  
raam.mainloop()
#=============== Programmi lõpp ================================
