#================ Programm =================================
from tkinter import *
#-------------- VAREM KIRJELDATUD FUNKTSIOONID --------------------------------------------------------------------
def punkt(koordinaadid,**kwargs):
    x = round(koordinaadid[0],2)
    y = round(koordinaadid[1],2)
    nimi = kwargs.get('nimi',None)
    tahvel.create_oval(x-1,y-1,x+2,y+2,fill='black')
    if nimi != None:
        nimi=nimi+'('+str(x)+','+str(y)+')'
        kesk = int(len(nimi)/2)
        fondikorgus = 8
        tahvel.create_text(x-kesk,y+fondikorgus,font='Times '+str(fondikorgus),text=nimi,fill='red')
    return
#---------------- Sirge joonestamine ---------------------------------------------------------
def sirge(A,B,**kwargs):
    # Antud: kahe erineva punkti A ja B koordinaadid
    # Joonestada: selline osa punkte A ja B läbivast sirgest, mis ulatub üle punktide A ja B
    #----------------------------------------------------------------------------------------
    # Joonestame punktid funktsiooniga punkt(koordinaadid,nimi)
    vxrv = kwargs.get('vxrv', None)
    punkt(A,nimi = 'A')
    punkt(B,nimi = 'B')
    #kahe punktiga määratud sirge võrrand (y-y1)(x2-x1)=(x-x1)(y2-y1) [võrde põhiomadus]
    #eraldame koordinaadid
    x1,y1 = A
    x2,y2 = B
    #sirge võrrandi jaoks leiame sirge tõusu ja vabaliikme (y=ax+b)
    if x1 == x2:
        if y1==y2:
            print("Punktid A ja B ühtivad")
            sys.exit()
        #kui x- koordinaadid kattuvad, on tegu vertikaalse sirgega ja tõusu arvutamisel tuleks 0ga jagamine
        else:
            a = None
            b = x1
            print('x='+str(b))
            tahvel.create_line((b,0),(b,600))
    else:
        a = (y2-y1)/(x2-x1) 
        b = y1 - a * x1        #
        # kui tõus a = 0
        if a == 0:
            tahvel.create_line((0,b),(800,b),fill=vxrv)
        else:
            xa = int(-1 * (b / a))        # kui y = 0
            xl = int((600 - b) / a)       # kui y = tahvli alumine serv
            #print(xa,xl)
            tahvel.create_line((xa,0),(xl,600),fill=vxrv)
        # kuna tegemist on arvuti koordinaatteljestikuga, siis tuleb sirge võrrandi väljakirjutamiseks võtta tõusu vastandarv
        print('y='+str(round(-1*a,2))+'x+'+str(round(b,2)))
    #kui peaks edaspidi vaja minema tõusu (a) ja vabaliiget (b), siis anname need kaasa
    return a,b
#-------------------- sisend ----------------------------
raam = Tk()
raam.title("Tahvel")
tahvel = Canvas(raam, width=800, height=600, background="white")
fail = open("Sisend_V-G-3.txt","r")
avaldis = fail.readline()
A = avaldis.split(',')
A[0] = int(A[0])
A[1] = int(A[1])
avaldis = fail.readline()
B = avaldis.split(',')
B[0] = int(B[0])
B[1] = int(B[1])
fail.close()
# Kui on soov teist värvi sirget joonestada, siis on võimalik lisada värv. Pole kohustuslik.
sirge(A,B,vxrv="red")
tahvel.pack()  
raam.mainloop()
#==================== Programmi lõpp ========================================
